using System;
using Infragistics.Win.UltraWinDataSource;

public static class UltraDataSourceHelper
{
    #region Private Fields
    #endregion // Private Fields

    #region Constructors/Destructors

    #endregion // Constructors/Destructors

    #region Public Properties
    #endregion // Public Properties

    #region Public Methods

    
    public static UltraDataBand CreateChildBand(UltraDataRow parentDataRow, string bandNamePattern, int bandNameIndex)
    {
        return parentDataRow.Band.ChildBands.Count == 0
                   ? CreateBandClone(parentDataRow.Band,
                                     GenerateBandName(parentDataRow.DataSource.Band, bandNamePattern, bandNameIndex))
                   : parentDataRow.Band.ChildBands[0];
    }

    
    public static UltraDataBand CreateBandClone(UltraDataBand parentBand, string key)
    {
        //DataBand
        UltraDataBand dataBand = parentBand.ChildBands.Add(key);
        dataBand.ReadOnly = parentBand.ReadOnly;
        foreach (UltraDataColumn dataColumn in parentBand.Columns)
        {
            UltraDataColumn customColumn = dataBand.Columns.Add(dataColumn.Key, dataColumn.DataType);
            customColumn.ReadOnly = dataColumn.ReadOnly;
            customColumn.Tag = dataColumn.Tag;
        }

        return dataBand;
    }

    
    public static string GenerateBandName(UltraDataBand band, string bandNamePattern, int bandNameIndex)
    {
        if (!band.Key.Contains(String.Format(bandNamePattern, bandNameIndex)))
        {
            if (band.ChildBands.Count > 0)
            {
                foreach (UltraDataBand childBand in band.ChildBands)
                    return GenerateBandName(childBand, bandNamePattern, bandNameIndex);
            }
            else//Last band
            {
                return String.Format(bandNamePattern, bandNameIndex);
            }
        }
        bandNameIndex++;
        return GenerateBandName(band, bandNamePattern, bandNameIndex);
    }

    #endregion // Public Methods

    #region Public Events
    #endregion  // Public Events

    #region Public Indexers
    #endregion  // Public Indexers

    #region Non-Public Methods/Events/Indexers
    #endregion // Non-Public Methods/Events/Indexers
}